;;; Copyright (C) 1984 by Gold Hill Computers

;;;	(APROPOS string &optional package)
;;;	    Prints out information about every symbol
;;;	    which contains string in its print name.

(DEFUN APROPOS (STRG &OPTIONAL PACKAGE)
  (LET ((LST (APROPOS-LIST STRG PACKAGE))
	(TEMP)
	(*PRINT-LENGTH* NIL))
    (DOLIST (S LST)
      (WHEN (BOUNDP S) (FORMAT *STANDARD-OUTPUT* "~%~S - bound" S))
      (WHEN (FBOUNDP S)
        (COND ((SPECIAL-FORM-P S)
	       (FORMAT *STANDARD-OUTPUT* "~%~S - special form" S))
	      ((MACRO-FUNCTION S)
	       (FORMAT *STANDARD-OUTPUT* "~%~S - macro" S))
	      ((CONSP (SETQ TEMP (SYMBOL-FUNCTION S)))
               (SETF TEMP (SECOND TEMP))
	       (FORMAT *STANDARD-OUTPUT*
	          "~%~S - function, arglist: ~:[~S~;()~]"
	          S (NULL TEMP) TEMP))
	      (T (FORMAT *STANDARD-OUTPUT* "~%~S - function" S))))
      (UNLESS (OR (BOUNDP S)(FBOUNDP S))
        (FORMAT *STANDARD-OUTPUT* "~%~S" S)))
    (TERPRI *STANDARD-OUTPUT*)))
